Index: /events/src/main/java/geniusweb/inform/Voting.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Voting.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/Voting.java	(revision 21)
@@ -0,0 +1,81 @@
+package geniusweb.inform;
+
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+
+/**
+ * Informs a party that it's time to do voting.
+ */
+public class Voting implements Inform {
+
+	private final List<Bid> bids;
+	private final Map<PartyId, Integer> powers;
+
+	@JsonCreator
+	public Voting(@JsonProperty("bids") List<Bid> bids,
+			@JsonProperty("powers") Map<PartyId, Integer> powers) {
+		this.bids = bids;
+		this.powers = powers;
+	}
+
+	/**
+	 * @return list of bids to be voted on
+	 */
+	public List<Bid> getBids() {
+		return Collections.unmodifiableList(bids);
+	}
+
+	/**
+	 * 
+	 * @return map with the power of each party in the negotiation. This map may
+	 *         contain parties that are already finished, eg they reached an
+	 *         agreement or walked away.
+	 */
+	public Map<PartyId, Integer> getPowers() {
+		return Collections.unmodifiableMap(powers);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((bids == null) ? 0 : bids.hashCode());
+		result = prime * result + ((powers == null) ? 0 : powers.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Voting other = (Voting) obj;
+		if (bids == null) {
+			if (other.bids != null)
+				return false;
+		} else if (!bids.equals(other.bids))
+			return false;
+		if (powers == null) {
+			if (other.powers != null)
+				return false;
+		} else if (!powers.equals(other.powers))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "Voting[" + bids + "," + powers + "]";
+	}
+
+}
Index: /events/src/main/java/geniusweb/inform/YourTurn.java
===================================================================
--- /events/src/main/java/geniusweb/inform/YourTurn.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/YourTurn.java	(revision 21)
@@ -0,0 +1,28 @@
+package geniusweb.inform;
+
+/**
+ * Informs a party that he has the turn and can choose the next action.
+ */
+public class YourTurn implements Inform {
+
+	@Override
+	public int hashCode() {
+		return 1;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "YourTurn";
+	}
+}
Index: /events/src/test/java/actions/VoteTest.java
===================================================================
--- /events/src/test/java/actions/VoteTest.java	(revision 21)
+++ /events/src/test/java/actions/VoteTest.java	(revision 21)
@@ -0,0 +1,99 @@
+package actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VoteTest extends GeneralTests<Vote> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private final static Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private final static String ISSUE1 = "issue1";
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private final static String ISSUE2 = "issue2";
+	private final static Value VALUE2 = new NumberValue("10");
+	// issue 2 is NUMBER and thus serializes with leading '='
+	private final String votestring = "{\"vote\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1}}";
+
+	private static Vote vote1, vote1a, vote2, vote3, vote4;
+
+	static {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+		bid = new Bid(issuevalues);
+		vote1 = new Vote(id, bid, 1);
+		vote1a = new Vote(id, bid, 1);
+
+		vote2 = new Vote(id2, bid, 1);
+
+		// values swapped, so different issuevalues.
+		issuevaluesb.put(ISSUE1, VALUE2);
+		issuevaluesb.put(ISSUE2, VALUE2);
+		bidb = new Bid(issuevaluesb);
+		vote3 = new Vote(id, bidb, 1);
+
+		vote4 = new Vote(id, bid, 2);
+
+	}
+
+	@Override
+	public List<List<Vote>> getGeneralTestData() {
+		List<List<Vote>> list = new LinkedList<>();
+		list.add(Arrays.asList(vote1, vote1a));
+		list.add(Arrays.asList(vote2));
+		list.add(Arrays.asList(vote3));
+		list.add(Arrays.asList(vote4));
+		return list;
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Vote.*party1.*issue2=10.*issue1=.value1.*1.*",
+				"Vote.*party2.*issue2=10.*issue1=.value1.*1.*",
+				"Vote.*party1.*issue2=10.*issue1=10.*1.*",
+				"Vote.*party1.*issue2=10.*issue1=.value1.*2.*");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(vote1));
+		assertEquals(votestring, jackson.writeValueAsString(vote1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(votestring, Action.class);
+		assertEquals(vote1, act);
+	}
+
+}
Index: /events/src/test/java/actions/VotesTest.java
===================================================================
--- /events/src/test/java/actions/VotesTest.java	(revision 21)
+++ /events/src/test/java/actions/VotesTest.java	(revision 21)
@@ -0,0 +1,108 @@
+package actions;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VotesTest extends GeneralTests<Votes> {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private final String votestring = "{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2}},{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2}}]}}";
+
+	private PartyId partyA = new PartyId("partyA");
+	private PartyId partyB = new PartyId("partyB");
+	private Bid bid1 = new Bid("is1", new DiscreteValue("val1")),
+			bid2 = new Bid("is1", new DiscreteValue("val2"));
+	private Vote voteA1 = new Vote(partyA, bid1, 2);
+	private Vote voteA2 = new Vote(partyA, bid2, 2);
+	private Vote voteB1 = new Vote(partyB, bid1, 2);
+	private Vote voteB2 = new Vote(partyB, bid2, 2);
+
+	private Votes votes1 = new Votes(partyA, Arrays.asList(voteA1, voteA2));
+	private Votes votes1a = new Votes(partyA, Arrays.asList(voteA1, voteA2));
+	private Votes votes2 = new Votes(partyB, Arrays.asList(voteB1, voteB2));
+
+	@Override
+	public List<List<Votes>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(votes1, votes1a),
+				Arrays.asList(votes2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Votes.*Vote.*partyA,Bid.*is1.*val1.*2.*Vote.*partyA,Bid.*is1.*val2.*2.*",
+				"Votes.*Vote.*partyB,Bid.*is1.*val1.*2.*Vote.*partyB,Bid.*is1.*val2.*2.*");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRejectVoteWithIncorrectParty() {
+		new Votes(partyA, Arrays.asList(voteB1));
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(votes1));
+		assertEquals(votestring, jackson.writeValueAsString(votes1));
+	}
+
+	@Test
+	public void deserializeTest() throws IOException {
+		Action act = jackson.readValue(votestring, Action.class);
+		assertEquals(votes1, act);
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWrongPartyName() {
+		new Votes(partyA, Arrays.asList(voteB1, voteB2));
+	}
+
+	@Test
+	public void isExtendingTestExtraVote() {
+		Votes otherVotes = new Votes(partyA, Arrays.asList(voteA1));
+		assertTrue(votes1.isExtending(otherVotes));
+	}
+
+	@Test
+	public void isExtendingTestNoVotes() {
+		Votes otherVotes = new Votes(partyA, Arrays.asList());
+		assertTrue(votes1.isExtending(otherVotes));
+	}
+
+	@Test
+	public void isExtendingTestMissing() {
+		Votes otherVotes = new Votes(partyA, Arrays.asList(voteA1));
+		assertFalse(otherVotes.isExtending(votes1));
+	}
+
+	@Test
+	public void isExtendingTestLessPower() {
+		Vote powervoteA1 = new Vote(partyA, bid1, 3);
+		Votes powerVotes = new Votes(partyA, Arrays.asList(powervoteA1));
+		assertFalse(powerVotes.isExtending(votes1));
+		assertTrue(votes1.isExtending(powerVotes));
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testDuplicateBidsNotAllowed() {
+		Vote voteA1similar = new Vote(partyA, bid1, 3);
+		Votes votes = new Votes(partyA, Arrays.asList(voteA1, voteA1similar));
+	}
+}
Index: /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java
===================================================================
--- /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 20)
+++ /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 21)
@@ -19,13 +19,13 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Value;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: /exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java
===================================================================
--- /exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java	(revision 20)
+++ /exampleparties/anac2019/agentgg/src/test/java/geniusweb/exampleparties/agentgg/AgentGGTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
Index: /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java
===================================================================
--- /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 20)
+++ /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 21)
@@ -19,4 +19,9 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
@@ -26,9 +31,4 @@
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: /exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java
===================================================================
--- /exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java	(revision 20)
+++ /exampleparties/anac2019/winkyagent/src/test/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgentTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
Index: /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java
===================================================================
--- /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 20)
+++ /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 21)
@@ -12,11 +12,11 @@
 import geniusweb.actions.ElicitComparison;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profile.Profile;
Index: /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java
===================================================================
--- /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 20)
+++ /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 21)
@@ -29,9 +29,9 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java
===================================================================
--- /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java	(revision 20)
+++ /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/BiddingInfo.java	(revision 21)
@@ -13,7 +13,7 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profileconnection.ProfileInterface;
Index: /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java
===================================================================
--- /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 20)
+++ /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 21)
@@ -11,12 +11,12 @@
 import geniusweb.actions.Action;
 import geniusweb.actions.Offer;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
 import geniusweb.party.Party;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 20)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 21)
@@ -29,6 +29,6 @@
 import geniusweb.actions.Accept;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 20)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 21)
@@ -27,10 +27,10 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java	(revision 20)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/MyGUITest.java	(revision 21)
@@ -19,6 +19,6 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java	(revision 20)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/TestConnection.java	(revision 21)
@@ -8,5 +8,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 import geniusweb.references.Reference;
 import tudelft.utilities.listener.DefaultListenable;
Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 20)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 21)
@@ -5,6 +5,8 @@
 import java.util.Arrays;
 import java.util.HashSet;
+import java.util.List;
 import java.util.Random;
 import java.util.logging.Level;
+import java.util.stream.Collectors;
 
 import geniusweb.actions.Accept;
@@ -12,13 +14,17 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
 import geniusweb.bidspace.AllPartialBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.OptIn;
+import geniusweb.inform.Settings;
+import geniusweb.inform.Voting;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profile.Profile;
@@ -33,4 +39,7 @@
  * A simple party that places random bids and accepts when it receives an offer
  * with sufficient utility.
+ * <h2>voting</h2> If the party receives a parameter "minPower", it will
+ * {@link Vote} using that minPower instead of the default value 2 if it
+ * receives a {@link Voting} request.
  */
 public class RandomParty extends DefaultParty {
@@ -41,4 +50,6 @@
 	protected ProfileInterface profileint;
 	private Progress progress;
+	private Settings settings;
+	private Votes lastvotes;
 
 	public RandomParty() {
@@ -58,4 +69,5 @@
 				this.me = settings.getID();
 				this.progress = settings.getProgress();
+				this.settings = settings;
 			} else if (info instanceof ActionDone) {
 				Action otheract = ((ActionDone) info).getAction();
@@ -64,10 +76,16 @@
 				}
 			} else if (info instanceof YourTurn) {
-				myTurn();
-				if (progress instanceof ProgressRounds) {
-					progress = ((ProgressRounds) progress).advance();
-				}
+				makeOffer();
+				nextRound();
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
+			} else if (info instanceof Voting) {
+				lastvotes = vote((Voting) info);
+				getConnection().send(lastvotes);
+				nextRound();
+			} else if (info instanceof OptIn) {
+				// just repeat our last vote.
+				getConnection().send(lastvotes);
+				nextRound();
 			}
 		} catch (Exception e) {
@@ -76,7 +94,15 @@
 	}
 
+	private void nextRound() {
+		if (progress instanceof ProgressRounds) {
+			progress = ((ProgressRounds) progress).advance();
+		}
+
+	}
+
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+		return new Capabilities(
+				new HashSet<>(Arrays.asList("SAOP", "AMOP", "MOPAC")));
 	}
 
@@ -86,7 +112,12 @@
 	}
 
-	private void myTurn() throws IOException {
+	/**
+	 * send our next offer
+	 */
+	private void makeOffer() throws IOException {
 		Action action;
-		if (isGood(lastReceivedBid)) {
+		String protocol = settings.getProtocol().getURI().getPath();
+		if ((protocol.equals("SAOP") || protocol.equals("SHAOP"))
+				&& isGood(lastReceivedBid)) {
 			action = new Accept(me, lastReceivedBid);
 		} else {
@@ -105,17 +136,42 @@
 	}
 
-	private boolean isGood(Bid bid) throws IOException {
+	/**
+	 * @param bid the bid to check
+	 * @return true iff bid is good for us.
+	 */
+	private boolean isGood(Bid bid) {
 		if (bid == null)
 			return false;
-		Profile profile = profileint.getProfile();
-		if (profile instanceof UtilitySpace) {
+		Profile profile;
+		try {
+			profile = profileint.getProfile();
+		} catch (IOException e) {
+			throw new IllegalStateException(e);
+		}
+		if (profile instanceof UtilitySpace)
 			return ((UtilitySpace) profile).getUtility(bid).doubleValue() > 0.6;
-		}
 		if (profile instanceof PartialOrdering) {
 			return ((PartialOrdering) profile).isPreferredOrEqual(bid,
 					profile.getReservationBid());
 		}
-		throw new IllegalArgumentException(
-				"Can not handle profile type " + profile.getClass());
+		return false;
+	}
+
+	/**
+	 * @param voting the {@link Voting} object containing the options
+	 * 
+	 * @return our next Votes.
+	 */
+	private Votes vote(Voting voting) throws IOException {
+		Object val = settings.getParameters().get("minPowwer");
+		Integer n = (val instanceof Integer) ? (Integer) val : 2;
+		for (Bid bid : voting.getBids()) {
+			System.out.println("Bid " + bid + "="
+					+ ((UtilitySpace) profileint.getProfile()).getUtility(bid));
+		}
+		List<Vote> votes = voting.getBids().stream().distinct()
+				.filter(bid -> isGood(bid)).map(bid -> new Vote(me, bid, n))
+				.collect(Collectors.toList());
+		return new Votes(me, votes);
 	}
 
Index: /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 20)
+++ /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 21)
@@ -16,4 +16,6 @@
 import java.nio.file.Files;
 import java.nio.file.Paths;
+import java.util.Arrays;
+import java.util.Collections;
 import java.util.LinkedList;
 import java.util.List;
@@ -32,13 +34,15 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.Voting;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
@@ -53,4 +57,5 @@
 public class RandomPartyTest {
 
+	private static final PartyId PARTY1 = new PartyId("party1");
 	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
@@ -60,5 +65,5 @@
 	private RandomParty party;
 	private final TestConnection connection = new TestConnection();
-	private final ProtocolRef protocol = mock(ProtocolRef.class);
+	private final ProtocolRef protocol = new ProtocolRef(SAOP);
 	private final ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
@@ -70,5 +75,5 @@
 			IOException, URISyntaxException {
 		party = new RandomParty();
-		settings = new Settings(new PartyId("party1"),
+		settings = new Settings(PARTY1,
 				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
 				parameters);
@@ -189,4 +194,19 @@
 	}
 
+	@Test
+	public void testVoting() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		Bid bid = findGoodBid();
+		party.notifyChange(new Voting(Arrays.asList(bid),
+				Collections.singletonMap(PARTY1, 1)));
+		assertEquals(1, connection.getActions().size());
+		Action action = connection.getActions().get(0);
+		assertTrue(action instanceof Votes);
+		assertEquals(1, ((Votes) action).getVotes().size());
+		assertEquals(bid, ((Votes) action).getVotes().get(0).getBid());
+	}
+
 }
 
Index: /exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 20)
+++ /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 21)
@@ -2,8 +2,8 @@
 import traceback
 
-import geniusweb.party.inform.ActionDone as ActionDone
-import geniusweb.party.inform.Inform as Inform
-import geniusweb.party.inform.Settings as Settings
-import geniusweb.party.inform.YourTurn as YourTurn
+import geniusweb.inform.ActionDone as ActionDone
+import geniusweb.inform.Inform as Inform
+import geniusweb.inform.Settings as Settings
+import geniusweb.inform.YourTurn as YourTurn
 
 
Index: /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java
===================================================================
--- /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 20)
+++ /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 21)
@@ -32,10 +32,10 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java
===================================================================
--- /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 20)
+++ /exampleparties/simpleboa/src/main/java/geniusweb/exampleparties/simpleboa/SimpleBoa.java	(revision 21)
@@ -8,8 +8,8 @@
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
 import geniusweb.boa.biddingstrategy.TimeDependentBiddingStrategy;
+import geniusweb.inform.Settings;
 import geniusweb.opponentmodel.FrequencyOpponentModel;
 import geniusweb.opponentmodel.OpponentModel;
 import geniusweb.party.Party;
-import geniusweb.party.inform.Settings;
 import tudelft.utilities.logging.Reporter;
 
